//Worksheet 6 problem 1
#include <string.h>
#include <mpi.h>
#include <stdio.h>
#include <stdlib.h>

int main(int argc, char ** argv)
{
  int rank, size, i;
  char * sendMsg = "Message to send";
  char recvMsg[20];
  MPI_Init(&argc, &argv);

  MPI_Comm_size(MPI_COMM_WORLD, &size);
  MPI_Comm_rank(MPI_COMM_WORLD, &rank);

  if(rank == 0)
  {
    //Send 7 messages (hint use 7 tags 0,1,...,6)
    for(i = 0; i < 7; i++)
      MPI_Send(sendMsg, strlen(sendMsg)+1, MPI_CHAR, 1, i, MPI_COMM_WORLD);
    printf("Sent 7 messages from process rank 0\n");
  }
  else if(rank == 1)
  {
    //Receive 7 messages (hint use the same 7 tags 0,1,...,6)
    for(i = 0; i < 7; i++)
    {
      MPI_Recv(recvMsg, 20, MPI_CHAR, 0, i, MPI_COMM_WORLD, MPI_STATUS_IGNORE);
      printf("Received %s from process rank 0 in process rank 1 with tag %d\n", recvMsg, i);
    }
  }

  MPI_Finalize();
  return 0;
}
